#include "Board.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////

// O[oϐ
Board g_Board;

////////////////////////////////////////////////////////////////////////////////////////////////////////////

Board::Board()
{
	// ΂̏Ԑݒ
	ZeroMemory( &m_nStone , sizeof( m_nStone ) );
	m_nStone[3][3] = Black;
	m_nStone[4][4] = Black;
	m_nStone[3][4] = White;
	m_nStone[4][3] = White;
}
Board::~Board()
{
}


// WM_PAINTbZ[Wnh
void Board::OnPaint( HWND hWnd )
{
	HDC			hDC;
	PAINTSTRUCT	ps;
	HBRUSH		hGreenBrush;
	HBRUSH		hWhiteBrush;
	HBRUSH		hBlackBrush;
	HBRUSH		hOldBrush;
	HPEN		hBlackPen;
	HPEN		hOldPen;

	// uV쐬
	hGreenBrush = CreateSolidBrush( RGB(  0,100,  0) );
	hWhiteBrush = CreateSolidBrush( RGB(255,255,255) );
	hBlackBrush = CreateSolidBrush( RGB(  0,  0,  0) );

	// y쐬
	hBlackPen = CreatePen( PS_SOLID , 1 , RGB(0,0,0) );

	// foCXReLXg擾
	hDC = BeginPaint( hWnd , &ps );

	/********* {[hn *********/
	hOldBrush = (HBRUSH)SelectObject( hDC , hGreenBrush );
	// hԂ
	PatBlt( hDC , MASS_POS_X , MASS_POS_Y ,
				MASS_SIZE_W * MASS_NUM_X ,
				MASS_SIZE_H * MASS_NUM_Y ,
				PATCOPY );
	SelectObject( hDC , hOldBrush );

	/********* {[hr *********/
	hOldPen = (HPEN)SelectObject( hDC , hBlackPen );
	// cr
	for( int x=0 ; x<MASS_NUM_X ; ++x )
	{
		MoveToEx( hDC , x * MASS_SIZE_W + MASS_POS_X , MASS_POS_Y , NULL );
		LineTo( hDC , x * MASS_SIZE_W + MASS_POS_X , MASS_NUM_Y * MASS_SIZE_H + MASS_POS_Y );
	}
	// r
	for( int y=0 ; y<MASS_NUM_Y ; ++y )
	{
		MoveToEx( hDC , MASS_POS_X , y * MASS_SIZE_H + MASS_POS_Y , NULL );
		LineTo( hDC , MASS_NUM_X * MASS_SIZE_W + MASS_POS_X , y * MASS_SIZE_H + MASS_POS_Y );
	}
	SelectObject( hDC , hOldPen );

	/********* Ε` *********/
	for( int y=0 ; y<MASS_NUM_Y ; ++y )
	{
		for( int x=0 ; x<MASS_NUM_X ; ++x )
		{
			switch( m_nStone[x][y] )
			{
			case None:	// uĂȂ
				break;

			case Black:	// 
				hOldBrush = (HBRUSH)SelectObject( hDC , hBlackBrush );
				hOldPen   = (HPEN)  SelectObject( hDC , hBlackPen   );
				// ~̕`
				Ellipse( hDC , x * MASS_SIZE_W + MASS_POS_X , y * MASS_SIZE_H + MASS_POS_Y ,
							   (x+1) * MASS_SIZE_W + MASS_POS_X , (y+1) * MASS_SIZE_H + MASS_POS_Y );
				SelectObject( hDC , hOldBrush );
				SelectObject( hDC , hOldPen   );
				break;

			case White:	// 
				hOldBrush = (HBRUSH)SelectObject( hDC , hWhiteBrush );
				hOldPen   = (HPEN)  SelectObject( hDC , hBlackPen   );
				// ~̕`
				Ellipse( hDC , x * MASS_SIZE_W + MASS_POS_X , y * MASS_SIZE_H + MASS_POS_Y ,
							   (x+1) * MASS_SIZE_W + MASS_POS_X , (y+1) * MASS_SIZE_H + MASS_POS_Y );
				SelectObject( hDC , hOldBrush );
				SelectObject( hDC , hOldPen   );
				break;
			}
		}
	}

	TCHAR str[] = TEXT("NbNō΁AENbNō΂u܂B");
	TextOut( hDC , 5 , 5 , str , lstrlen( str ) );

	// foCXReLXg
	EndPaint( hWnd , &ps );

	// y
	DeleteObject( hBlackPen );

	// uV
	DeleteObject( hGreenBrush );
	DeleteObject( hWhiteBrush );
	DeleteObject( hBlackBrush );
}

// WM_LBUTTONDOWNbZ[Wnh
void Board::OnLButtonDown( HWND hWnd , int x , int y )
{
	// Ή}Xɍzu
	if( MASS_POS_X <= x && x < MASS_POS_X + MASS_SIZE_W * MASS_NUM_X &&
		MASS_POS_Y <= y && y < MASS_POS_Y + MASS_SIZE_H * MASS_NUM_Y )
	{
		int nMassX = (x-MASS_POS_X) / MASS_SIZE_W;
		int nMassY = (y-MASS_POS_Y) / MASS_SIZE_H;
		m_nStone[nMassX][nMassY] = Black;
	}

	// ʍXV
	// WM_PAINTĂяo
	InvalidateRect( hWnd , NULL , FALSE );
}

// WM_RBUTTONDOWNbZ[Wnh
void Board::OnRButtonDown( HWND hWnd , int x , int y )
{
	// Ή}Xɔzu
	if( MASS_POS_X <= x && x < MASS_POS_X + MASS_SIZE_W * MASS_NUM_X &&
		MASS_POS_Y <= y && y < MASS_POS_Y + MASS_SIZE_H * MASS_NUM_Y )
	{
		int nMassX = (x-MASS_POS_X) / MASS_SIZE_W;
		int nMassY = (y-MASS_POS_Y) / MASS_SIZE_H;
		m_nStone[nMassX][nMassY] = White;
	}

	// ʍXV
	// WM_PAINTĂяo
	InvalidateRect( hWnd , NULL , FALSE );
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
